#include "iarduino_I2C_IO.h"
//		Объявление экземпляра класса			([адрес модуля])
		iarduino_I2C_IO::iarduino_I2C_IO		(uint8_t k)	{if(k>=0x20 && k<=0x27){EXP_uint_ADDRESS_OBJ=k;}}

//		Инициация работы модуля					()
void	iarduino_I2C_IO::begin					(){I2C_func_BEGIN();}				//	Инициируем работу по шине I2C

//		Установка режима работы вывода			(№ вывода,	режим работы)
void	iarduino_I2C_IO::pinMode				(uint8_t i,	uint8_t j){
			if(!EXP_func_FIND(i,EXP_REG_CONFIG)){return;}							//	Определяем адрес модуля на шине I2C, адрес регистра и номер вывода
			I2C_func_READ();														//	Читаем данные из указанного регистра в переменную EXP_uint_DATA
			if(j==OUTPUT)	{EXP_uint_DATA&=~_BV(EXP_uint_BIT);}					//	Сбрасываем    бит, соответствующего вывода, в прочтённых данных
			else			{EXP_uint_DATA|= _BV(EXP_uint_BIT);}					//	Устанавливаем бит, соответствующего вывода, в прочтённых данных
			I2C_func_WRITE();														//	Записываем данные из переменной EXP_uint_DATA в регистр EXP_uint_COMMAND модуля с адресом EXP_uint_ADDRESS
}

//		Установка логического состояния			(№ вывода,	состояние)
void	iarduino_I2C_IO::digitalWrite			(uint8_t i,	bool j){
			if(!EXP_func_FIND(i,EXP_REG_OUTPUT)){return;}							//	Определяем адрес модуля на шине I2C, адрес регистра и номер вывода
			I2C_func_READ();														//	Читаем данные из указанного регистра в переменную EXP_uint_DATA
			if(!j)			{EXP_uint_DATA&=~_BV(EXP_uint_BIT);}					//	Сбрасываем    бит, соответствующего вывода, в прочтённых данных
			else			{EXP_uint_DATA|= _BV(EXP_uint_BIT);}					//	Устанавливаем бит, соответствующего вывода, в прочтённых данных
			I2C_func_WRITE();														//	Записываем данные из переменной EXP_uint_DATA в регистр EXP_uint_COMMAND модуля с адресом EXP_uint_ADDRESS
}

//		Чтение логического состояния			(№ вывода)
bool	iarduino_I2C_IO::digitalRead			(uint8_t i){
			if(!EXP_func_FIND(i,EXP_REG_INPUT)){return LOW;}						//	Определяем адрес модуля на шине I2C, адрес регистра и номер вывода
			I2C_func_READ();														//	Читаем данные из регистра EXP_uint_COMMAND модуля с адресом EXP_uint_ADDRESS в переменную EXP_uint_DATA
			return EXP_uint_DATA&=_BV(EXP_uint_BIT);
}

//		Определение параметров для передачи		(№ вывода,	адрес регистра)
bool	iarduino_I2C_IO::EXP_func_FIND			(uint8_t i,	uint8_t j){
			EXP_uint_COMMAND=j;
			EXP_uint_BIT=i%8;
			if(EXP_uint_ADDRESS_OBJ<255)		{EXP_uint_ADDRESS=EXP_uint_ADDRESS_OBJ;	return i<=7?true:false;}
			if(i>=64)							{										return           false;}
			EXP_uint_ADDRESS=(i/8)+0x20;												return true;
}

/** внутренние функции для работы с шиной I2C **/
void	iarduino_I2C_IO::I2C_func_START			()										{int I2C_var_I=0;    I2C_mass_STATUS[2]=1; TWCR = _BV(TWINT) | _BV(TWEN) | _BV(TWSTA); while(!(TWCR & _BV(TWINT))){I2C_var_I++; if(I2C_var_I>I2C_mass_STATUS[1]){I2C_mass_STATUS[2]=0; break;}} I2C_mass_STATUS[3] = TWSR & 0xF8; if(I2C_mass_STATUS[3]!=0x08){I2C_mass_STATUS[2]=0;}}
void	iarduino_I2C_IO::I2C_func_RESTART		()										{int I2C_var_I=0; if(I2C_mass_STATUS[2]){  TWCR = _BV(TWINT) | _BV(TWEN) | _BV(TWSTA); while(!(TWCR & _BV(TWINT))){I2C_var_I++; if(I2C_var_I>I2C_mass_STATUS[1]){I2C_mass_STATUS[2]=0; break;}} I2C_mass_STATUS[3] = TWSR & 0xF8; if(I2C_mass_STATUS[3]!=0x10){I2C_mass_STATUS[2]=0;}}}
void	iarduino_I2C_IO::I2C_func_SEND_ID		(uint8_t I2C_byte_ID, bool I2C_bit_RW)	{int I2C_var_I=0; if(I2C_mass_STATUS[2]){  TWDR = (I2C_byte_ID<<1)+I2C_bit_RW; TWCR = _BV(TWINT) | _BV(TWEN); while(!(TWCR & _BV(TWINT))){I2C_var_I++; if(I2C_var_I>I2C_mass_STATUS[1]){I2C_mass_STATUS[2]=0; break;}} I2C_mass_STATUS[3] = TWSR & 0xF8; if(I2C_bit_RW){ if(I2C_mass_STATUS[3]!=0x40){I2C_mass_STATUS[2]=0;}}else{if(I2C_mass_STATUS[3]!=0x18){I2C_mass_STATUS[2]=0;}}}}
void	iarduino_I2C_IO::I2C_func_WRITE_BYTE	(uint8_t I2C_byte_DATA)					{int I2C_var_I=0; if(I2C_mass_STATUS[2]){  TWDR = I2C_byte_DATA; TWCR = _BV(TWINT) | _BV(TWEN); while(!(TWCR & _BV(TWINT))){I2C_var_I++; if(I2C_var_I>I2C_mass_STATUS[1]){I2C_mass_STATUS[2]=0; break;}} I2C_mass_STATUS[3] = TWSR & 0xF8; if(I2C_mass_STATUS[3]!=0x28){I2C_mass_STATUS[2]=0;}}}
uint8_t	iarduino_I2C_IO::I2C_func_READ_BYTE		(bool I2C_bit_ACK)						{int I2C_var_I=0; if(I2C_mass_STATUS[2]){  TWCR = _BV(TWINT) | _BV(TWEN) | I2C_bit_ACK<<TWEA; while(!(TWCR & _BV(TWINT))){I2C_var_I++; if(I2C_var_I>I2C_mass_STATUS[1]){I2C_mass_STATUS[2]=0; break;}} I2C_mass_STATUS[3] = TWSR & 0xF8; if(I2C_bit_ACK){if(I2C_mass_STATUS[3]!=0x50){I2C_mass_STATUS[2]=0;}}else{if(I2C_mass_STATUS[3]!=0x58){I2C_mass_STATUS[2]=0;}} return TWDR;}else{return 0xFF;}}
void	iarduino_I2C_IO::I2C_func_STOP			()										{int I2C_var_I=0; TWCR = _BV(TWINT) | _BV(TWEN) | _BV(TWSTO); while(!(TWCR & _BV(TWSTO))){I2C_var_I++; if(I2C_var_I>I2C_mass_STATUS[1]){I2C_mass_STATUS[2]=0; break;}} delayMicroseconds(20);}
void	iarduino_I2C_IO::I2C_func_BEGIN			()										{    I2C_mass_STATUS[2]=1; TWBR=((F_CPU/(I2C_mass_STATUS[0]*1000))-16)/2; if(TWBR<10){TWBR=10;} TWSR&=(~(_BV(TWPS1)|_BV(TWPS0)));}

void	iarduino_I2C_IO::I2C_func_READ(){											//	Читаем данные из модуля
			I2C_func_START();														//	Отправляем команду START
			I2C_func_SEND_ID(EXP_uint_ADDRESS, 0);									//	Отправляем адрес модуля и бит RW=0 (запись данных в датчик)
			I2C_func_WRITE_BYTE(EXP_uint_COMMAND);									//	Отправляем адрес регистра, данные которого требуется прочитать
			I2C_func_RESTART();														//	Отправляем команду RESTART
			I2C_func_SEND_ID(EXP_uint_ADDRESS, 1);									//	Отправляем адрес модуля и бит RW=1 (чтение данных из датчика)
			EXP_uint_DATA=I2C_func_READ_BYTE(false);								//	Читаем байт данных с отправкой бита NACK
			I2C_func_STOP();														//	Отправляем команду STOP
}
void	iarduino_I2C_IO::I2C_func_WRITE(){											//	Записываем данные в датчик
			I2C_func_START();														//	Отправляем команду START
			I2C_func_SEND_ID(EXP_uint_ADDRESS, 0);									//	Отправляем адрес модуля и бит RW=0 (запись данных в датчик)
			I2C_func_WRITE_BYTE(EXP_uint_COMMAND);									//	Отправляем адрес регистра, данные которого требуется прочитать
			I2C_func_WRITE_BYTE(EXP_uint_DATA);										//	Отправляем байт данных в указанный регистр
			I2C_func_STOP();														//	Отправляем команду STOP
}
